<%

CLASS DidYouMean
''''''''''''''''''''''''''''''''''''''''''''
'  SEARCH ENGINE SPELLING SUGGESTION CLASS '
'         MS VBSCRIPT CLASS FOR ASP3       '
''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''
'                 EXPLICIT                 '
''''''''''''''''''''''''''''''''''''''''''''
Private G_Languages
Private G_deleteTypos
Private G_hasSuggestions
''''''''''''''''''''''''''''''''''''''''''''
'               END  EXPLICIT              '
''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''
'       DICTIONARY SELECTION INTERFACE     '
''''''''''''''''''''''''''''''''''''''''''''
public property get languages
Languages = G_Languages
end property

public property let languages(input)
G_Languages = replace(""&input,"&","")
end property
''''''''''''''''''''''''''''''''''''''''''''
'   END  DICTIONARY SELECTION INTERFACE    '
''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''
'               PROPERTIES                 '
''''''''''''''''''''''''''''''''''''''''''''
public property get deleteTypos
deleteTypos = G_deleteTypos
end property

public property let deleteTypos(input)
G_deleteTypos = (Trim(LCase(input&""))="true")
end property

public property get hasSuggestions
hasSuggestions = G_hasSuggestions
end property
''''''''''''''''''''''''''''''''''''''''''''
'             END  PROPERTIES              '
''''''''''''''''''''''''''''''''''''''''''''

public function suggestionString(byval strInput)
	' RETURNS A SINGLE SUGGESTION STRING BASED ON A SEARCH STRING	
	if  noSession then
		strInput = server.URLEncode(strInput)
		suggestionString = strGetURL(  myhttppath() & "ASPDidYouMean.asp?Lang="&G_Languages&"deleteTypos="&G_deleteTypos&"&in=" & strInput)
	else
		On Error Resume Next
		session("ASPDIDYOUMEAN_LANGUAGES") = G_Languages
		session("ASPDIDYOUMEAN_INPUT") = strInput
		session("ASPDIDYOUMEAN_METHOD") = "Default"
		session("ASPDIDYOUMEAN_DELETETYPOS") = G_deleteTypos
		server.Execute(executionPath)
		suggestionString = session("ASPDIDYOUMEAN_OUTPUT")
		
		G_hasSuggestions=  (trim(suggestionString&"")<>strInput) AND (trim(suggestionString&"")<>"") 	
		
		if err.Number<>0 then call writeWarning
		on Error Goto 0
	end if

	call CleanSession()

end function


public function SuggestionMatrix(byval strInput, binFull)
	' SUGGESTS POSSIBLE SPELLINGS FOR EVERY WORD IN THE STRING 
	' SUGGESTIONS ARE ONLY MADE FOR INCORRECTLY SPELLED WORDS UNLESS binFull IS SET TRUE
	' RETURNS A 2 DIMENSIONAL SET - AN IRREGULAR 2 DIMENSIONAL ARRAY
	' THE FIRST ORDER OF THE SET CORRESPONDS TO EACH WORD IN THE  INPUT STRING
	' THE SECOND ORDER OF THE SET CORRESPONDS TO EACH POSSIBLE SPELLING OF THAT WORD
	
	' E.G.  SuggestionMatrix(strInput,binFull)(2)(3)  RETURNS THE 4TH SUGGESTION PROBABLE SPELLING OF THE 3RD WORD IN THE SEARCH STRING
	dim  strMatrix
	dim  strMethod
	if binFull then  strMethod="full_matrix" else strMethod="matrix"
	
	if  noSession then
		strInput = server.URLEncode(strInput)
		strMatrix = strGetURL(  myhttppath() & "ASPDidYouMean.asp?Lang="&G_Languages&"deleteTypos="&G_deleteTypos&"&method="&strMethod&"&in=" & strInput)

	else
		On Error Resume Next
		session("ASPDIDYOUMEAN_LANGUAGES") = G_Languages
		session("ASPDIDYOUMEAN_METHOD") = UCASE(strMethod)
		session("ASPDIDYOUMEAN_INPUT") = strInput
		session("ASPDIDYOUMEAN_DELETETYPOS") = G_deleteTypos
		server.Execute(executionPath)
		strMatrix = session("ASPDIDYOUMEAN_OUTPUT")
		
		G_hasSuggestions=  True
		
		if err.Number<>0 then call writeWarning
		on Error Goto 0
	end if

	SuggestionMatrix = Deserialise(strMatrix,false)

	call CleanSession()
end function

public function SuggestionStrings(byval strInput,byval intMax)
	' SUGGESTS N (intMax) POSSIBLE SPELLINGS FOR THE INPUT STRING, ORDERED BY THE MOST PROBABLE FIRST
	' RETURNS A 1 DIMENSIONAL  ARRAY
	' EACH ITEM OF THE ARRAY IS A FULL SUGGESTED SEARCH STRING
	' E.G.  SuggestionStrings(2) RETURNS THE 3TH MOST PROBABLE SPELLING OF THE SEARCH STRING	
	

	dim strMatrix, strCombinations, arrMatrix, arrCombinations, strFull, arrFull, arrOut, strTemp,i,j

	if  noSession then
		strInput = server.URLEncode(strInput)
		strFull = strGetURL(  myhttppath() & "ASPDidYouMean.asp?Lang="&G_Languages&"deleteTypos="&G_deleteTypos&"&method=top&max=" & intMax & "&in=" & strInput)
	else	
		On Error Resume Next
		session("ASPDIDYOUMEAN_LANGUAGES") = G_Languages
		session("ASPDIDYOUMEAN_INPUT") = strInput
		session("ASPDIDYOUMEAN_METHOD") = "top"
		session("ASPDIDYOUMEAN_MAX") = intMax
		session("ASPDIDYOUMEAN_DELETETYPOS") = G_deleteTypos
		server.Execute(executionPath)
		strFull = session("ASPDIDYOUMEAN_OUTPUT")
		if err.Number<>0 then call writeWarning
		on Error Goto 0
	end if

	arrFull = split(strFull,"===============DLIMIT================")

	strMatrix = arrFull(0)
	strCombinations = arrFull(1)

	arrMatrix = Deserialise(strMatrix,false)
	arrCombinations = Deserialise(strCombinations,true)
	arrOut = array()
	redim arrOut (ubound(arrCombinations))
	
	

	for i = 0 to ubound(arrCombinations)
		strTemp = ""

		for j = 0 to ubound(arrCombinations(i))
			strTemp = strTemp & "" & arrMatrix(j)(  int(arrCombinations(i)(j) ))
		next

		arrOut(i) = strTemp
	next

	
	
	G_hasSuggestions=  false
	if Ubound(arrOut)>-1 then
	 if trim(arrOut(0)&"")<>strInput and  trim(arrOut(0)&"")<>"" then G_hasSuggestions=true
	end if 
	
	SuggestionStrings = arrOut
	
	call CleanSession()
end function

''''''''''''''''''''''''''''''''''''''''''''
'               END PUBLIC                 '
''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''
'                 PRIVATE                  '
''''''''''''''''''''''''''''''''''''''''''''

private sub  CleanSession()
	On Error Resume Next
	session("ASPDIDYOUMEAN_INPUT") = ""
	session("ASPDIDYOUMEAN_METHOD") = ""
	session("ASPDIDYOUMEAN_OUTPUT") = ""
	session("ASPDIDYOUMEAN_MAX") = ""
	session("ASPDIDYOUMEAN_LANGUAGES") = ""
	session("ASPDIDYOUMEAN_DELETETYPOS") = ""
	on error goto 0
end sub

private function Deserialise(ArrMatrix,binCondensed)

	dim i,ArrMatrixOut, dlimit
	if  binCondensed then dlimit = " " else dlimit = "<||>"
	ArrMatrix = split(ArrMatrix,vbcrlf)
	ArrMatrixOut = array()
	redim ArrMatrixOut (ubound(ArrMatrix))

	for i = 0 to ubound(ArrMatrix)
		ArrMatrixOut(i) = split(ArrMatrix(i),dlimit)
	next

	Deserialise = ArrMatrixOut
	call CleanSession()
end function

private Function strGetURL(strURL)
	DIM objXmlHttp
	DIM strHTML
	On Error Resume Next

	SET objXmlHttp = Server.CreateObject("Microsoft.XMLHTTP")
	objXmlHttp.Open "GET", strURL, false
	objXmlHttp.send
	strHTML = objXmlHttp.responseText
	SET objXmlHttp = NOTHING
	strGetURL = strHTML
	if err.Number<>0 then call writeWarning
	on error goto 0
End Function

private sub writeWarning

response.write ("<hr><em>ASPDidYouMean Error - Installation Incomplete.  Please refer to the settings file and to the manual.</em><hr>")
end sub

private function myhttppath()
dim Default_Language
dim DictionaryPath
dim Custom_Word_List
dim Banned_Word_List
dim Case_Sensitive
dim Installation_Path
%><!--#include file="settings.inc"--><%

	myhttppath = "http://" & replace(request.ServerVariables("REMOTE_HOST") &"/"& Installation_Path&"/","//","/")
end function

private function executionPath()
dim Default_Language
dim DictionaryPath
dim Custom_Word_List
dim Banned_Word_List
dim Case_Sensitive
dim Installation_Path
%><!--#include file="settings.inc"--><%
	executionPath=replace("/"& Installation_Path&"/ASPDidYouMean.asp","//","/")
end function

private function noSession()
	On Error Resume Next
	Session.Contents("Test")
	noSession = (Err.number <> 0)
	on error goto 0
end function

''''''''''''''''''''''''''''''''''''''''''''
'               END PRIVATE                '
''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''
'           CLASS INSTANTIATION            '
''''''''''''''''''''''''''''''''''''''''''''

private sub Class_Initialize()
	G_Languages = ""
	G_deleteTypos=false
	G_hasSuggestions=false
end sub

private sub Class_Terminate()
end sub

''''''''''''''''''''''''''''''''''''''''''''
'         END CLASS INSTANTIATION          '
''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''
'            END DIDYOUMEAN CLASS          '
''''''''''''''''''''''''''''''''''''''''''''
END CLASS %>